
!include <sculptor.h> 
!include <printer.h> 

!include "ex2.h"

!ofile customer   "../data/customer"    read 
!ofile ordhead    "../data/ordhead"     read 
!ofile ordline    "../data/ordline"     read 


!record OrdRepStuff {

	rep_months ,, n8.0[12]/my 
	SDate      , "Start Date",  i4/dn
	EDate      , "End Date",    i4/dn

	Margin1    ,, i2 
	Margin2    ,, i2 
	
	fflag      ,, u1
}

	MainProgram()
	
!function MainProgram() {

	SDate = sys.Date - 2*365 
	EDate = sys.Date
	
	rbgPrintDest.Button1->checked = TRUE  
	Margin1 = 5 
	Margin2 = Margin1 + 5 

	display wintask 

	dialog wintask cancel = MP_DONE
MP_DONE:

	ExitProgram() 

}


!function ExitProgram() {
	exit
}

!function evRunReport(evcode, evobj) {

	if ( evobj ?= bgReport.Button1 ) {
		
		if ( rbgPrintDest.Button1->checked ) {
			run report CustRep
		} else {
			run report CustRep to "print manager"
		} 

		return
	}
	

	if ( rbgPrintDest.Button1->checked ) {
		run report OrdersReport
	} else {
		run report CustRep to "print manager"
	} 

}

!report OrdersReport {
!drive ordhead 
!xfile customer key = ordhead.CustCode 

!select if ( ordhead.OrderDate >= SDate and ordhead.OrderDate <= EDate ) 


!init {
!temp i  ,, i1

	if ( SDate > EDate ) {
		error "Dates are wrong  " 
		abort
	}

	sys.PageLength  = 30
	sys.FootLines = 5

	for ( i = 1; i <= 12; i++ ) {
		rep_months[i] = 0 
	}

	fflag = FALSE
}

!heading {

	if ( fflag ) {
		print "Monthly amounts "
		return 
	}

	sys.LeftMargin = Margin1 
	printh *ordhead.OrderNo, *ordhead.OrderDate, *customer.Name , *ordhead.OrdTotal

	sys.LeftMargin = Margin2 
	printh *ordline.OrderNo,*ordline.LineNo, *ordline.PartCode, *ordline.Qty

	print
	print
}

!footnote {

	if ( fflag ) return 

	print
	print 
	print sys.PageNumber

}

!final {

	print 
	print "Total of all orders in report ", total(ordhead.OrdTotal) /100 : "######0.##" 

	print 

	ShowMonthlyTotals()
}


	/* driving logic */
	PrintOrdHead()
	PrintOrdLines() 
	SetMonthTotals() 
	end 

}

!function ShowMonthlyTotals() {
!temp i ,, i2 

	fflag = TRUE 

_bp	newpage 
	print
	for ( i= 1; i <=12 ; i++ ) {
		print  MonthString(i) , rep_months[i] 
	}

}

!function PrintOrdHead() {
	
	sys.LeftMargin = Margin1
	printh ordhead.OrderDate, customer.Name, ordhead.OrdTotal

}

!function PrintOrdLines() {

	sys.LeftMargin = Margin2
	find ordline key = ordhead.OrderNo traps = IGNORE 
	if ( sys.Traps <> OKAY ) {
		print "Error - No orderlines for this order head " 
		return
	}

POL_LOOP:

	printh ordline.LineNo, ordline.PartCode, ordline.Qty
	match ordline traps = IGNORE 
	if ( sys.Traps = OKAY ) goto POL_LOOP 


	print 
	print
}

!function SetMonthTotals() {
!temp d ,, i1
!temp m ,, i1
!temp y ,, i4

	decdate(d,m,y,ordhead.OrderDate) 
	if ( m >0 ) {
		rep_months[m] = rep_months[m] + ordhead.OrdTotal
	}
	
}



/**********************************************************************************************/
!report CustRep {
!drive customer 

!select if ( customer.CreditLimit < customer.Balance - customer.CreditLimit/10   ) 

!heading {

	printh *customer.Name , *customer.CreditLimit, *customer.Balance 
	print 

}

	printh customer.Name, customer.CreditLimit, customer.Balance 
	end


}

!function MonthString(mno) {

	switch ( mno ) {
	case = 1  : return "Jan"
	case = 2  : return "Feb"
	case = 3  : return "Mar"
	case = 4  : return "Apr"
	case = 5  : return "May"
	case = 6  : return "Jun"
	case = 7  : return "Jul"
	case = 8  : return "Aug"
	case = 9  : return "Sep"
	case = 10 : return "Oct"
	case = 11 : return "Nov"
	case = 12 : return "Dec"
	default   : return "Err"
  
	}

}



