

!define MAX_ORDLINES 10 


/*

	ex1.r 

*/

!include <sculptor.h> 

!include "ex1.h" 

!file customer "../data/customer"
!file stockitem "../data/stockitem"
!file ordhead "../data/ordhead"
!file ordline "../data/ordline"

!record ProgParams {
	Server,,a32
	DataPath,,a32
}

!record OrdLinesGrid  {
	PartCode    ,"Part Code",  a20[MAX_ORDLINES]
	Qty         ,"Qty", i4[MAX_ORDLINES]
}

!record GridCellProps {
	cell_type ,, i4[2]
}

 
	MainProg() 


!function MainProg() {

	GridCellProps.cell_type[1] = TCT_TEXTBOX
	GridCellProps.cell_type[2] = TCT_TEXTBOX
 

	OpenFiles() 
	evNext()

	open Tab1
	display wintask

	dialog wintask cancel = MP_DONE
MP_DONE:


	ExitProgram()

}

!function ExitProgram() {
	exit
}


!function DisplayOrder() {

	if ( sys.Traps <> OKAY ) {
		error "Error "
		clear wintask
		return
	} 

	AssignToGrid(ordhead.OrderNo) 
	display wintask

}    

!function evPrev() {
	
	prev ordhead traps = IGNORE 
	DisplayOrder() 
}

!function evNext() {
	next ordhead traps = IGNORE 
	DisplayOrder() 
}


!function evSave() {

	check ordhead traps = IGNORE
	if ( sys.Traps <> OKAY ) {
		insert ordhead
	} else {
		write ordhead
	}

	AssignToOrdLineFile(ordhead.OrderNo)

	caption "Order saved" 
}


!function evNew() {
!temp i ,, i2 
!temp nordno ,, i4

_bp	wind ordhead 
	prev ordhead traps = IGNORE 
	if ( sys.Traps = OKAY)  nordno = ordhead.OrderNo + 1 else nordno = 1

	clear 

	for ( i = 1; i <= MAX_ORDLINES ;i++ ) {
		OrdLinesGrid.Qty[i] = 0  
		OrdLinesGrid.PartCode[i] = ""  
	}

	clear wintask 
	ordhead.OrderNo = nordno 
	ordhead.OrderDate = sys.Date 
	display wintask 

	caption "New order on screen . Don't forget to save "
	setfocus(Textbox2) 
}



!function OpenFiles() {
!temp nval ,, i2 

	
	nval = read_json_values("ex1.json", ProgParams ) 
	if ( nval = 0 ) {
		error "Could not read json file"
		exit
	}

	openfile customer  name = Server / DataPath /  "/customer" 
	openfile stockitem name = Server / DataPath /  "/stockitem" 
	openfile ordhead   name = Server / DataPath /  "/ordhead" 
	openfile ordline   name = Server / DataPath /  "/ordline" 
 
}

!function AssignToGrid(ordno) {
!temp i   ,, i2 

	for ( i = 1; i <= MAX_ORDLINES ; i++ ) {
		readu ordline key = ordno,i traps = IGNORE 
		if ( sys.Traps = OKAY ) {
			OrdLinesGrid.PartCode[i] = ordline.PartCode
			OrdLinesGrid.Qty[i] = ordline.Qty
		} else {
			OrdLinesGrid.PartCode[i] = ""
			OrdLinesGrid.Qty[i]      = 0
		}
	}


}

!function AssignToOrdLineFile(ordno) {
!temp i   ,, i2 

	for ( i = 1; i <= MAX_ORDLINES ; i++ ) {

		if ( OrdLinesGrid.PartCode[i] = "" ) break
 
		read ordline key = ordno,i traps = IGNORE 
		ordline.Qty  = OrdLinesGrid.Qty[i]  
		ordline.PartCode  = OrdLinesGrid.PartCode[i]  

		if ( sys.Traps = OKAY ) {
			write ordline 
		} else {
			ordline.OrderNo = ordno
			ordline.LineNo  = i
			insert ordline
		}
	}


}


