

/*

	example.r - menus 
                close/cancel dialog 
                validation functions , setfocus 
                event function parameters
				hide/show, enable/disable, TABSTOP 
				modal non-modal dialogs 

*/

!include <sculptor.h> 

!chargrid OFF


+window wintask at 68,29 {
	max_width = 1137
	max_height = 591
	event = ExitProgram
	style = WS_CLOSEBUTTON | WS_MAXBUTTON | WS_MINBUTTON
	title = "Edit stock and customers"

	+text StaticText1 at 301,255 {
		label = "Select menu options to start dialogs"
		label_font = "Garamond@24"
		width = 459
		height = 35
	}

	menu MainMenu {

		menuitem MenuItem1 {
			label = "Exit"
			select = ExitProgram
		}

		menuitem MenuItem2 {
			label = "Edit Customers"
			select = EditCustomers
		}

		menuitem MenuItem3 {
			label = "Edit stockitems"
			select = EditStockItems
		}
	}
}

-window winCustomer at 10,10 {
	max_width = 990
	max_height = 581
	title = "Edit customers. Press ESC to get out"

	+graphic Graphic1 at 118,230 {
		type = GT_IMAGE
		width = 407
		height = 242
	}

	+textbox Textbox1 at 201,84 {
		field = customer.Code
	}

	+textbox Textbox2 at 203,126 {
		field = customer.Name
	}

	+textbox Textbox3 at 207,173 {
		field = customer.Passwd
	}

	+textbox Textbox4 at 204,393 {
		field = customer.PostCode
	}

	+textbox Textbox5 at 203,255 {
		field = customer.Addr1
	}

	+textbox Textbox6 at 202,307 {
		field = customer.Addr2
	}

	+textbox Textbox7 at 203,344 {
		field = customer.Addr3
	}

	+button Button1 at 534,66 {
		label = "Next Item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evNextCustomer
	}

	+button Button2 at 699,68 {
		label = "Prev item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evPrevCustomer
	}

	+button Button3 at 536,134 {
		label = "Wind to start"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evCustomerFileStart
	}

	+button Button4 at 699,136 {
		label = "Wind to end"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evCustomerFileEnd
	}

	menu Menu1 {

		menuitem MenuItem1 {
			label = "MenuItem1"
		}

		menuitem MenuItem2 {
			label = "MenuItem2"
		}

		menuitem MenuItem3 {
			label = "MenuItem3"
		}

		menuitem MenuItem4 {
			label = "MenuItem4"
		}

		menuitem MenuItem5 {
			label = "MenuItem5"
		}

		menuitem MenuItem6 {
			label = "MenuItem6"
		}
	}
}


-window winStockItem at 129,42 {
	max_width = 990
	max_height = 581
	title = "Edit stock items. Press ESC to get out"

	+textbox Textbox1 at 297,79 {
		field = stockitem.Code
	}

	+textbox Textbox2 at 301,122 {
		field = stockitem.Desc
	}

	+textbox Textbox3 at 303,174 {
		field = stockitem.InStock
	}

	+textbox Textbox4 at 305,218 {
		field = stockitem.Price
	}

	+textbox Textbox5 at 306,270 {
		field = stockitem.SDate
	}

	+textbox Textbox6 at 305,324 {
		field = stockitem.Weight
	}

	+button Button1 at 116,410 {
		label = "Next Item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evNextStock
	}

	+button Button2 at 308,411 {
		label = "Prev item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evPrevStock
	}

	+button Button3 at 116,457 {
		label = "Wind to start"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evStockFileStart
	}

	+button Button4 at 308,458 {
		label = "Wind to end"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evStockFileEnd
	}
}


!ofile customer "../data/customer" update
!ofile stockitem "../data/stockitem" update


	ExampleMain() 


!function ExitProgram(evcode,evobj) {

	if ( evcode = EV_CLOSE or evcode = EV_MENU ) exit

}

!function ExampleMain() {


	open MainMenu
	dialog wintask 

}
!function EditStockItems() {

	open winStockItem
	dialog winStockItem cancel = ESI_DUN
ESI_DUN:
 
	close winStockItem
}

!function EditCustomers() {

	open Menu1
	open winCustomer
	dialog winCustomer cancel = EC_DUN
EC_DUN:

	close winCustomer
}


!function evNextStock() {
	next stockitem 
	display winStockItem
}

!function evPrevStock() {
	prev stockitem 
	display winStockItem
}

!function evStockFileStart() {
	rewind stockitem 
	clear winStockItem
}

!function evStockFileEnd() {

	wind stockitem 
	clear winStockItem
}





!function evNextCustomer() {
	next customer 
	display winCustomer
}

!function evPrevCustomer() {
	prev customer 
	display winCustomer
}

!function evCustomerFileStart() {
	rewind customer 
	clear winCustomer
}

!function evCustomerFileEnd() {

	wind customer 
	clear winCustomer
}




