

/*

	example.r - 
               
*/

!include <sculptor.h> 

!chargrid OFF


+window wintask at 122,89 {
	max_width = 1137
	max_height = 591
	event = ExitProgram
	style = WS_CLOSEBUTTON | WS_MAXBUTTON | WS_MINBUTTON
	title = "Edit stock and customers"

	+graphic Graphic1 at 135,124 {
		type = GT_VLINE
		height = 60
	}

	+text StaticText1 at 299,142 {
		label = "Select menu options to start dialogs"
		label_font = "Garamond@24"
		width = 459
		height = 35
	}

	menu MainMenu {

		menuitem MenuItem1 {
			label = "Exit"
			select = ExitProgram
		}

		menuitem MenuItem2 {
			label = "Edit Customers"
			select = CustomerWin
		}

		menuitem MenuItem3 {
			label = "Edit stockitems"
			select = StockItemWin
		}

		menuitem MenuItem4 {
			label = "Show settings"
			select = ShowSettings
		}
	}
}

-window winCustomer at 11,10 {
	max_width = 990
	max_height = 581
	event_enable = EV_CLOSE
	event = evCloseCustomerWin
	style = WS_CLOSEBUTTON
	title = "Edit customers. Press ESC to get out"

	+graphic Graphic1 at 118,230 {
		type = GT_IMAGE
		width = 407
		height = 242
	}

	+textbox Textbox1 at 201,84 {
		field = customer.Code
		validate = ValCustCode
	}

	+textbox Textbox2 at 203,126 {
		field = customer.Name
	}

	+textbox Textbox3 at 207,173 {
		field = customer.Passwd
	}

	+textbox Textbox4 at 204,393 {
		field = customer.PostCode
	}

	+textbox Textbox5 at 203,255 {
		field = customer.Addr1
	}

	+textbox Textbox6 at 202,307 {
		field = customer.Addr2
	}

	+textbox Textbox7 at 203,344 {
		field = customer.Addr3
	}

	+button Button1 at 534,66 {
		label = "Next Item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evNextCustomer
	}

	+button Button2 at 756,68 {
		label = "Prev item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evPrevCustomer
	}

	+button Button3 at 536,134 {
		label = "Wind to start"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evCustomerFileStart
	}

	+button Button4 at 756,136 {
		label = "Wind to end"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evCustomerFileEnd
	}

	+button Button5 at 544,272 {
		label = "Close this dialog OK"
		style = WS_DEFAULT_BUTTON
		width = 179
		height = 51
		event_enable = EV_BUTTON_CLICKED
		event = evOKCustomerDialog
	}

	+button Button6 at 757,269 {
		label = "Cancel"
		width = 145
		height = 52
		event_enable = EV_BUTTON_CLICKED
		event = evCancelCustomerDialog
	}

	+button Button7 at 540,208 {
		label = "write existing"
		width = 156
		height = 36
		event_enable = EV_BUTTON_CLICKED
		event = evWriteCustomer
	}

	+button Button8 at 758,209 {
		label = "NEW"
		width = 106
		height = 36
		event_enable = EV_BUTTON_CLICKED
		event = evNewCustomer
	}

	+button Button9 at 558,412 {
		label = "Save New"
		style = WS_INVISIBLE
		width = 106
		height = 36
		event_enable = EV_BUTTON_CLICKED
		event = evInsertNewCustomer
	}

	+button Button10 at 688,412 {
		label = "Cancel New"
		style = WS_INVISIBLE
		width = 106
		height = 36
		event_enable = EV_BUTTON_CLICKED
		event = evCancelNewCustomer
	}
}


-window winStockItem at 129,42 {
	max_width = 990
	max_height = 581
	title = "Edit stock items. Press ESC to get out"

	+textbox Textbox1 at 297,79 {
		field = stockitem.Code
		validate = ValStockCode
	}

	+textbox Textbox2 at 301,122 {
		field = stockitem.Desc
	}

	+textbox Textbox3 at 303,174 {
		field = stockitem.InStock
	}

	+textbox Textbox4 at 305,218 {
		field = stockitem.Price
	}

	+textbox Textbox5 at 306,270 {
		field = stockitem.SDate
	}

	+textbox Textbox6 at 305,324 {
		field = stockitem.Weight
	}

	+button Button1 at 116,410 {
		label = "Next Item"
		style = WS_DEFAULT_BUTTON
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evNavigateStockItem
	}

	+button Button2 at 308,411 {
		label = "Prev item"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evNavigateStockItem
	}

	+button Button3 at 116,457 {
		label = "Wind to start"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evStockWind
	}

	+button Button4 at 308,458 {
		label = "Wind to end"
		width = 118
		height = 35
		event_enable = EV_BUTTON_CLICKED
		event = evStockWind
	}
}


-window winSettings at 670,53 {
	max_width = 407
	max_height = 366
	event_enable = EV_CLOSE
	event = evCloseSettingsWin
	parent = wintask
	style = WS_CLOSEBUTTON
	title = "Settings info"

	+textbox Textbox1 at 108,53 {
		field = sys.Date
		style = WS_NOTABSTOP
	}

	+textbox Textbox2 at 114,104 {
		field = sys.Time
		style = WS_NOTABSTOP
	}

	+textbox Textbox3 at 108,154 {
		field = sys.IPAddress
		style = WS_NOTABSTOP
	}

	+textbox Textbox5 at 108,210 {
		field = sys.UserName
		style = WS_NOTABSTOP
	}
}


!ofile customer "../data/customer" update
!ofile stockitem "../data/stockitem" update


	ExampleMain() 


!function ExitProgram(evcode,evobj) {

	if ( evcode = EV_CLOSE or evcode = EV_MENU ) exit

}

!function ExampleMain() {

	open MainMenu
	dialog wintask 

}
!function ValStockCode() {

	info "don't like the stock code "

}

!function evCloseSettingsWin() {
	close winSettings
}

!function ShowSettings() {

	open winSettings
	display winSettings 

}

!function evCloseCustomerWin() {
	return CLOSE_DIALOG
}

!function evOKCustomerDialog() {

	return CLOSE_DIALOG 

}

!function evCancelCustomerDialog() {

	return CANCEL_DIALOG 

}

!function evWriteCustomer() {

	check customer traps = IGNORE
	if ( sys.Traps <> OKAY ) {
		error "You don't have a record selected to write back to file"
		return
	}

	write customer 
	read customer 

}

!function evNewCustomer() {
.. learn about groups to do this disable in one go 

	disable winCustomer.Button1, winCustomer.Button2, winCustomer.Button3, winCustomer.Button4, winCustomer.Button5 
	disable winCustomer.Button6, winCustomer.Button7, winCustomer.Button8

	show winCustomer.Button9, winCustomer.Button10  

	clear winCustomer 
	setfocus winCustomer.Textbox1 

	caption "Enter new data. Press OK or cancel to insert in customer file " 


}

!function evInsertNewCustomer() {

	insert customer traps = IGNORE 
	if ( sys.Traps <> OKAY ) {
		error "Record already exists or other insert error"
		return
	}

	read customer 

	enable winCustomer.Button1, winCustomer.Button2, winCustomer.Button3, winCustomer.Button4, winCustomer.Button5 
	enable winCustomer.Button6, winCustomer.Button7, winCustomer.Button8
	hide winCustomer.Button9,winCustomer.Button10 
	
}

!function evCancelNewCustomer() {

	clear winCustomer 

	enable winCustomer.Button1, winCustomer.Button2, winCustomer.Button3, winCustomer.Button4, winCustomer.Button5 
	enable winCustomer.Button6, winCustomer.Button7, winCustomer.Button8
	hide winCustomer.Button9,winCustomer.Button10 
	
}

!function ValCustCode() {

	if ( customer.Code bw "0" or customer.Code bw "O"  ) {
		bell
		error "Company codes may not begin with  zero or letter O"
		setfocus winCustomer.Textbox1  
	}

}


!function StockItemWin() {

	open winStockItem
	dialog winStockItem cancel = ESI_DONE
ESI_DONE:
 
	close winStockItem
}

!function CustomerWin() {

	open winCustomer
	dialog winCustomer cancel = EC_CANCEL

	info "Normal exit" 
	goto EC_DONE 

EC_CANCEL:
	info "dialog was cancelled" 

EC_DONE:

	close winCustomer
}


!function evNavigateStockItem(evcode, evobj) {


	if ( evobj ?= winStockItem.Button1 ) {
		next stockitem 
	} else {
		prev stockitem 
	}

	display winStockItem
}

!function evStockWind(evcode, evobj) {

	if ( evobj ?= winStockItem.Button3 ) {
		rewind stockitem 
	} else {
		wind stockitem 
	}

	clear winStockItem
}




!function evNextCustomer() {
	next customer 
	display winCustomer
}

!function evPrevCustomer() {
	prev customer 
	display winCustomer
}

!function evCustomerFileStart() {
	rewind customer 
	clear winCustomer
}

!function evCustomerFileEnd() {

	wind customer 
	clear winCustomer
}



