/* ordhead.r */

/********************************************************************************/

!include <sculptor.h>
!include <printer.h>

/********************************************************************************/

!define _FIND 1
!define _INSERT 2
!define _AMEND 3

!define _LOCK 1
!define _UNLOCK 2

/********************************************************************************/

!file FILE_ORDHEAD "../data/ordhead"

!record TMP_ORDHEAD = FILE_ORDHEAD
!record LastRec = FILE_ORDHEAD

/********************************************************************************/

!record DispListTable {
	OrderNo,"Order Number",i4
	CustCode,"Customer Code",a12
	OrderdDate,"Order Date",i4/dn
	PayMethod,"Visa/Delta/Account",u1
	OrderMethod,"phone/email/online",u1
	SDelivery,"Special deivery",u1
	OrdTotal,"Total Value of Order",n8.0/my
	Discount,"discount",n8.0/my
}

!record ListTableCellProps {
	cell_type,,i4[8]
	cell_width,,i2[8]
}


/********************************************************************************/

!temp CurrentIndex,,a32
!temp NumSelIndexes,,i2
!temp LastFindIndex,,a32
!temp CurrentIndexNum,,i2
!temp ContinueFind,,i2
!temp Selected,,i2
!temp Inserted,,i2
!temp CurrentOpt,,a20
!temp Found,,i2
!temp LockMain,,i2

/********************************************************************************/

+window wintask at 720, 327 {
	max_width = 480
	max_height = 385
	style = WS_CLOSEBUTTON | WS_MINBUTTON | WS_CAPTION
	event = WinTaskEvent
	title = "ordhead"
	data_font = "arial@8"
	label_font = "arial@8"

	+text IndexListText at 275, 15 {
		 label = "Index"
	}

	+listbox IndexList at 310, 10 {
		listbox_type = LIST_BUTTON
		width = 150
		rows = 2
		event = IndexListEvent
	}

	button group OptButs {

		+button FindBut at 330, 55 {
			label = "&Find"
			width = 60
			event = FindButEvent
			tooltip = "Find a record by full or partial key values"
		}

		+button NextBut at 330, 80 {
			label = "&Next"
			width = 60
			event = NextButEvent
			tooltip = "Display the next record in ascending key sequence"
		}

		+button PrevBut at 330, 105 {
			label = "&Prev"
			width = 60
			event = PrevButEvent
			tooltip = "Display the previous record in descending key sequence"
		}

		+button MatchBut at 330, 130 {
			label = "&Match"
			width = 60
			event = MatchButEvent
			tooltip = "Display the next record matching the values supplied for the last Find"
		}

		+button ReportBut at 330, 155 {
			label = "&Report"
			width = 60
			event = ReportButEvent
			tooltip = "Print a report on all records in columnar form, or on the selected record"
		}

		+button ListBut at 330, 180 {
			label = "&List"
			width = 60
			event = ListButEvent
			tooltip = "Display all records in table form"
		}

		+button InsertBut at 400, 55 {
			label = "&Insert"
			width = 60
			event = InsertButEvent
			tooltip = "Insert new records"
		}

		+button AmendBut at 400, 80 {
			label = "&Amend"
			width = 60
			event = AmendButEvent
			tooltip = "Amend the currently displayed record"
		}

		+button DeleteBut at 400, 105 {
			label = "&Delete"
			width = 60
			event = DeleteButEvent
			tooltip = "Delete the currently displayed record"
		}

		+button RewindBut at 400, 130 {
			label = "&Rewind"
			width = 60
			event = RewindButEvent
			tooltip = "Rewind the file (or current secondary index) to the start"
		}

		+button WindBut at 400, 155 {
			label = "&Wind"
			width = 60
			event = WindButEvent
			tooltip = "Wind the file (or current secondary index) to the end"
		}

		+button ExitBut at 400, 180 {
			label = "&Exit"
			width = 60
			event = ExitButEvent
			tooltip = "Exit program"
		}
	}

	button group ConfirmButs {
		style = WS_DISABLED


		+button OKBut at 330, 217 {
			label = "&OK"
			width = 60
			event = OKButEvent
			style = WS_DEFAULT_BUTTON
			tooltip = "Confirm the currently displayed data"
		}

		+button CancelBut at 400, 217 {
			label = "&Cancel"
			width = 60
			event = CancelButEvent
			style = WS_CANCEL_BUTTON
			tooltip = "Cancel the current option"
		}
	}

	textbox group KeyFields {
		style = WS_NOTABSTOP

		+textbox OrderNoBox at 108, 35 {
			field = TMP_ORDHEAD.OrderNo
			label = "Order Number"
			width = 78
		}
	}

	textbox group DataFields {
		style = WS_NOTABSTOP

		+textbox CustCodeBox at 108, 65 {
			field = TMP_ORDHEAD.CustCode
			label = "Customer Code"
			width = 84
		}

		+textbox OrderdDateBox at 108, 85 {
			field = TMP_ORDHEAD.OrderdDate
			label = "Order Date"
			width = 78
		}

		+textbox PayMethodBox at 108, 105 {
			field = TMP_ORDHEAD.PayMethod
			label = "Visa/Delta/Account"
			width = 30
		}

		+textbox OrderMethodBox at 108, 125 {
			field = TMP_ORDHEAD.OrderMethod
			label = "phone/email/online"
			width = 30
		}

		+textbox SDeliveryBox at 108, 145 {
			field = TMP_ORDHEAD.SDelivery
			label = "Special deivery"
			width = 30
		}

		+textbox OrdTotalBox at 108, 165 {
			field = TMP_ORDHEAD.OrdTotal
			label = "Total Value of Order"
			width = 108
		}

		+textbox DiscountBox at 108, 185 {
			field = TMP_ORDHEAD.Discount
			label = "discount"
			width = 108
		}
	}
}

-window winIndex1 at 856, 460 {
	max_width = 208
	max_height = 120
	title = "Find by Index idx_cust"
	parent = wintask
	style = WS_OWNED
	data_font = "arial@8"
	label_font = "arial@8"


	+textbox CustCodeBox11 at 84, 20 {
		field = TMP_ORDHEAD.CustCode
		label = "Customer Code"
		width = 84
	}

	+button Index1OKBut at 29, 60 {
		label = "&OK"
		width = 60
		event = OKFIButEvent
		style = WS_DEFAULT_BUTTON
		tooltip = "Confirm values for Find operation and close window"
	}

	+button Index1CancelBut at 104, 60 {
		label = "&Cancel"
		width = 60
		event = CancelFIButEvent
		style = WS_CANCEL_BUTTON
		tooltip = "Cancel the find operation"
	}
}


-window winList at 538, 295 {
	max_width = 844
	max_height = 450
	parent = wintask
	style = WS_OWNED
	title = "List of records"

	+table ListTable at 8, 20 {
		source_object = FILE_ORDHEAD
		display_object = DispListTable
		rows = 20
		cell_properties = ListTableCellProps
		event = ListTableEvent
		width = 819
	}

	+button OKListBut at 347, 390 {
		label = "&OK"
		width = 60
		event = OKListButEvent
		style = WS_DEFAULT_BUTTON
		tooltip = "Close window, displaying selected record (if any)"
	}

	+button CancelListBut at 422, 390 {
		label = "&Cancel"
		width = 60
		event = CancelListButEvent
		style = WS_CANCEL_BUTTON
		tooltip = "Close window without displaying a record"
	}
}

-window winReport at 810, 427 {
	max_width = 300
	max_height = 185
	parent = wintask
	style = WS_OWNED
	title = "Reports"
	+graphic Graphic1 at 24,12 {
		type = GT_RECTANGLE
		width = 245
		height = 76
		title = "Select report type"
	}

	radio group RepButs {

		+button RepAllBut at 93,32 {
			label = "&All records"
			tooltip = "Print a report of all records in the file, 1 record to a line"
		}

		+button RepCurrentBut at 93,52 {
			label = "&Displayed record"
			tooltip = "Print a report of all fields in the currently selected record"
		}
	}


	+button OKRepBut at 75, 125 {
		label = "&OK"
		width = 60
		event = OKRepButEvent
		style = WS_DEFAULT_BUTTON
		tooltip = "Print selected report"
	}

	+button CancelRepBut at 150, 125 {
		label = "&Cancel"
		width = 60
		event = CancelRepButEvent
		style = WS_CANCEL_BUTTON
		tooltip = "Close window without printing a report"
	}
}

/********************************************************************************/

-window winprompt at 920, 477 {
	parent = wintask
	data_font = "arial@10"
	label_font = "arial@10"
	title = "Sculptor"
}

/********************************************************************************/

	Main()
	exit

/********************************************************************************/

!function Main() {

	Initialise()

MAIN_DIALOG:
	dialog
	return
}

/********************************************************************************/

!function Initialise() {
	openfile FILE_ORDHEAD name = "../data/ordhead" update
	CurrentIndex = "Main"
	SetIndexNameList()
	SetListTableCellProps()
	EnableOptButs()
	return
}

/********************************************************************************/

!function WinTaskEvent(EventCode, Object) {

	switch (EventCode) {
	case = EV_CLOSE:
		exit
	}
	return
}

/********************************************************************************/

!function Clear() {
	clear wintask

	clear FILE_ORDHEAD
	clear TMP_ORDHEAD
	Selected = FALSE
	return
}

/********************************************************************************/

!function Display() {

	TMP_ORDHEAD = FILE_ORDHEAD
	display wintask
	Selected = TRUE
	LastRec = FILE_ORDHEAD
	sync_indexes FILE_ORDHEAD
	return
}

/********************************************************************************/

!function SetIndexNameList() {
	NumSelIndexes = 1
	listbox_add(IndexList,"Main", 0)
	listbox_add(IndexList,"idx_cust",0)
	set_selected(IndexList, 1, TRUE)
	return
}

/********************************************************************************/

!function IndexListEvent(EventCode, Object) {
	if (EventCode <> EV_SINGLE_CLICK) then return
	listbox_get_selected(IndexList, CurrentIndex, CurrentIndexNum)
	if (CurrentIndex <> LastFindIndex) or (Found = FALSE) then disable MatchBut else enable MatchBut
	return
}

/********************************************************************************/

!function FindButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	Clear()
	CurrentOpt = _FIND
	if (CurrentIndex = "Main") then FindMain()

	if (CurrentIndex = "idx_cust") {
		FindIndex(winIndex1)
	}
	return
}

/********************************************************************************/

!function FindMain() {

	disable OptButs
	enable ConfirmButs
	enable_tabstop KeyFields
	disable_tabstop IndexList
	SetFocusKey1()
	return
}

/********************************************************************************/

!function FindIndex(WinName) {

	clear WinName
	show WinName
	dialog WinName
	hide WinName
	if (ContinueFind = TRUE) then OKFind()
	return
}

/********************************************************************************/

!function OKFIButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return
	ContinueFind = TRUE
	return CANCEL_DIALOG
}

/********************************************************************************/

!function CancelFIButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return
	ContinueFind = FALSE
	return CANCEL_DIALOG
}

/********************************************************************************/

!function OKFind() {

	FILE_ORDHEAD = TMP_ORDHEAD
	if (CurrentIndex = "Main") {
		findu FILE_ORDHEAD nsr = FIND_NSR riu = FIND_RIU traps = FIND_TRAPS
	}

	if (CurrentIndex = "idx_cust") {
		findu FILE_ORDHEAD index = idx_cust nsr = FIND_NSR riu = FIND_RIU traps = FIND_TRAPS
	}

	Found = TRUE
	Display()
	DisableInput()
	LastFindIndex = CurrentIndex
	setfocus FindBut
	return

FIND_NSR:
	info "No record found"
	SetFocusKey1()
	return

FIND_RIU:
	info "Record is locked by another user"
	SetFocusKey1()
	return

FIND_TRAPS:
	info "Cannot find record (unknown error)"
	SetFocusKey1()
	return
}

/********************************************************************************/

!function NextButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (CurrentIndex = "Main") {
		nextu FILE_ORDHEAD nsr = NEXT_NSR riu = NEXT_RIU traps = NEXT_TRAPS
	}

	if (CurrentIndex = "idx_cust") {
		nextu FILE_ORDHEAD index = idx_cust nsr = NEXT_NSR riu = NEXT_RIU traps = NEXT_TRAPS
	}

	Display()
	EnableOptButs()
	return

NEXT_NSR:
	info "End of file"
	return

NEXT_RIU:
	info "Next record is locked by another user"
	return

NEXT_TRAPS:
	info "Cannot find next record"
	return
}

/********************************************************************************/

!function PrevButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (CurrentIndex = "Main") {
		prevu FILE_ORDHEAD nsr = PREV_NSR riu = PREV_RIU traps = PREV_TRAPS
	}

	if (CurrentIndex = "idx_cust") {
		prevu FILE_ORDHEAD index = idx_cust nsr = PREV_NSR riu = PREV_RIU traps = PREV_TRAPS
	}

	Display()
	EnableOptButs()
	return

PREV_NSR:
	info "Beginning of file"
	return

PREV_RIU:
	info "Previous record is locked by another user"
	return

PREV_TRAPS:
	info "Cannot find previous record"
	return
}

/********************************************************************************/

!function MatchButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (CurrentIndex = "Main") {
		matchu FILE_ORDHEAD nsr = MATCH_NSR riu = MATCH_RIU traps = MATCH_TRAPS
	}

	if (CurrentIndex = "idx_cust") {
		matchu FILE_ORDHEAD index = idx_cust nsr = MATCH_NSR riu = MATCH_RIU traps = MATCH_TRAPS
	}

	Display()
	EnableOptButs()
	return

MATCH_NSR:
	info "No more matching records"
	return

MATCH_RIU:
	info "Next matching record is locked by another user"
	return

MATCH_TRAPS:
	info "Cannot find matching record"
	return
}

/********************************************************************************/

!function ReportButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	show winReport
	switch (Selected) {
		case = FALSE:
			disable RepCurrentBut
			RepAllBut->checked = TRUE
			break

		case = TRUE:
			enable RepCurrentBut
			break
	}

	dialog winReport cancel = RE_CANCEL

RE_CANCEL:
	hide winReport
	return
}

/********************************************************************************/

!function OKRepButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (RepCurrentBut->checked = TRUE) {
		run report PrintCurrent to "printmanager" ppf = "winpm"
	}

	if (RepAllBut->checked = TRUE) {
		if (CurrentIndex = "Main") {
			run report PrintAll to "printmanager" ppf = "winpm"
		}

		if (CurrentIndex = "idx_cust") {
			run report PrintAll1 to "printmanager" ppf = "winpm"
		}
	}

	return CANCEL_DIALOG
}

/********************************************************************************/

!function CancelRepButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return
	return CANCEL_DIALOG
}

/********************************************************************************/

!function ListButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	destroy ListTable
	if (CurrentIndex = "Main") {
		ListTable->source_object = FILE_ORDHEAD
	}

	if (CurrentIndex = "idx_cust") {
		ListTable->source_object = FILE_ORDHEAD.idx_cust
	}

	winList->title = "List of records sorted by " + CurrentIndex / " index"
	create ListTable
	set_selected(ListTable, 0, FALSE)
	display ListTable

	show winList
	dialog winList
	hide winList
	return
}

/********************************************************************************/

!function DisplayListRec() {
	if (table_first_selected_key(ListTable) = OKAY) {
		if (ReadRecord(_UNLOCK, "Main") = OKAY) {
			sync_indexes FILE_ORDHEAD
			Display()
			EnableOptButs()
		}
	}
	return
}

/********************************************************************************/

!function OKListButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return
	DisplayListRec()
	return CANCEL_DIALOG
}

/********************************************************************************/

!function CancelListButEvent(EventCode, Object) {

	if (EventCode <> EV_BUTTON_CLICKED) then return
	return CANCEL_DIALOG
}

/********************************************************************************/

!function SetListTableCellProps() {

	ListTableCellProps.cell_type[1] = TCT_READONLY
	ListTableCellProps.cell_type[2] = TCT_READONLY
	ListTableCellProps.cell_type[3] = TCT_READONLY
	ListTableCellProps.cell_type[4] = TCT_READONLY
	ListTableCellProps.cell_type[5] = TCT_READONLY
	ListTableCellProps.cell_type[6] = TCT_READONLY
	ListTableCellProps.cell_type[7] = TCT_READONLY
	ListTableCellProps.cell_type[8] = TCT_READONLY
	create ListTable
	return
}

/********************************************************************************/

!function ListTableEvent(EventCode, Table, Line) {

	if (EventCode = EV_DOUBLE_CLICK) {
		DisplayListRec()
		return CANCEL_DIALOG
	}
	return
}

/********************************************************************************/

!function InsertButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	Clear()
	clear LastRec
	Inserted = FALSE
	CurrentOpt = _INSERT
	EnableInput()
	SetFocusKey1()
	return
}

/********************************************************************************/

!function OKInsert() {

	if (isblank(TMP_ORDHEAD)) {
		prompt "", \
			" Insert a record with all null values - are you sure? " \
				button = " Yes " \
				button = " No  ", INSERT_CONTINUE
	}

	CopyToFile()
	insert FILE_ORDHEAD re = INSERT_RE riu = INSERT_RIU traps = INSERT_TRAPS

	Selected = TRUE
	Inserted = TRUE
	LastRec = FILE_ORDHEAD
	Clear()
	EnableInput()
	SetFocusKey1()
	return

INSERT_RE:
	info "Record already exists with this key"

INSERT_CONTINUE:
	SetFocusKey1()
	return

INSERT_RIU:
	info "File has been locked by another process"
	SetFocusKey1()
	return

INSERT_TRAPS:
	info "Cannot insert record (unknown error)"
	SetFocusKey1()
	return
}

/********************************************************************************/

!function AmendButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return
	if (ReadRecord(_LOCK, "Main") = ERROR) then return

	CurrentOpt = _AMEND
	EnableInput()

	SetFocusKey1()
	return
}

/********************************************************************************/

!function OKAmend() {

	CopyToFile()
	write FILE_ORDHEAD re = AMEND_RE nrs = AMEND_NRS ue = AMEND_UE  traps = AMEND_TRAPS
	Selected = TRUE
	DisableInput()
	setfocus AmendBut
	return

AMEND_RE:
	info "Record already exists with this key"
	SetFocusKey1()
	return

AMEND_NRS:
	info "No record selected"
	Display()
	DisableInput()
	setfocus AmendBut
	return

AMEND_UE:
	info "Update refused - record updated by another user"
	Display()
	DisableInput()
	setfocus AmendBut
	return

AMEND_TRAPS:
	info "Cannot amend record (unknown error)"
	SetFocusKey1()
	return
}

/********************************************************************************/

!function DeleteButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return
	if (ReadRecord(_LOCK, "Main") = ERROR) then return

	prompt "", \
		" Delete this record? " \
			button = " Yes " \
			button = " No  ", DEL_RETURN

	delete FILE_ORDHEAD nrs = DEL_NRS traps = DEL_TRAPS
	Clear()
	EnableOptButs()
	return

DEL_NRS:
	info "No record selected"
	return

DEL_TRAPS:
	info "Unable to delete record"
	return

DEL_RETURN:
	unlock FILE_ORDHEAD
	return
}

/********************************************************************************/

!function RewindButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (CurrentIndex = "Main") {
		rewind FILE_ORDHEAD
	}

	if (CurrentIndex = "idx_cust") {
		rewind FILE_ORDHEAD index = idx_cust
	}

	Clear()

	switch(CurrentIndex) {
		case = "Main":
			caption "File has been rewound to the beginning"
			break

		default:
			caption "Index " + CurrentIndex / " has been rewound to the beginning"
			break
	}

	return
}

/********************************************************************************/

!function WindButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	if (CurrentIndex = "Main") {
		wind FILE_ORDHEAD
	}

	if (CurrentIndex = "idx_cust") {
		wind FILE_ORDHEAD index = idx_cust
	}

	Clear()

	switch(CurrentIndex) {
		case = "Main":
			caption "File has been wound to the end"
			break

		default:
			caption "Index " + CurrentIndex / " has been wound to the end"
			break
	}

	return
}

/********************************************************************************/

!function ExitButEvent(EventCode, Object) {
	if (EventCode = EV_BUTTON_CLICKED) then exit
	return
}

/********************************************************************************/

!function OKButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	switch (CurrentOpt) {
		case = _FIND:
			OKFind()
			break

		case = _INSERT:
			OKInsert()
			break

		case = _AMEND:
			OKAmend()
			break
	}
	return
}

/********************************************************************************/

!function CancelButEvent(EventCode, Object) {
	if (EventCode <> EV_BUTTON_CLICKED) then return

	switch (CurrentOpt) {
		case = _FIND:
			Clear()
			setfocus FindBut
			break

		case = _INSERT:
			DisplayLastRecord()
			setfocus InsertBut
			break

		case = _AMEND:
			unlock FILE_ORDHEAD
			Display()
			setfocus AmendBut
			break
	}

	DisableInput()
	return
}

/********************************************************************************/

!function EnableOptButs() {
	enable OptButs
	if (Found = FALSE) then disable MatchBut
	if (Selected = FALSE) then disable AmendBut, DeleteBut
	return
}

/********************************************************************************/

!function EnableInput() {
	disable_tabstop IndexList
	enable_tabstop KeyFields, DataFields
	disable OptButs
	enable ConfirmButs
	return
}

/********************************************************************************/

!function DisableInput() {
	enable_tabstop IndexList
	disable_tabstop KeyFields, DataFields
	disable ConfirmButs
	EnableOptButs()
	return
}

/********************************************************************************/

!function ReadRecord(Mode, Index) {

	if (Index = "") then Index = CurrentIndex
	if (Mode = _LOCK) {

		if (Index = "Main") {
			read FILE_ORDHEAD nsr = READ_NSR riu = READ_RIU traps = READ_TRAPS
		}

		if (Index = "idx_cust") {
			read FILE_ORDHEAD index = idx_cust nsr = READ_NSR riu = READ_RIU traps = READ_TRAPS
		}
	}

	if (Mode <> _LOCK) {

		if (Index = "Main") {
			readu FILE_ORDHEAD nsr = READ_NSR riu = READ_RIU traps = READ_TRAPS
		}

		if (Index = "idx_cust") {
			readu FILE_ORDHEAD index = idx_cust nsr = READ_NSR riu = READ_RIU traps = READ_TRAPS
		}
	}

	return OKAY

READ_NSR:
	info "Record has been deleted by another user"
	Clear()
	return ERROR

READ_RIU:
	info "Record is locked by another user"
	return ERROR

READ_TRAPS:
	info "Cannot reread record (unknown error)"
	return ERROR

}

/********************************************************************************/

!function CopyToFile() {
	FILE_ORDHEAD = TMP_ORDHEAD
	return
}

/********************************************************************************/

!function DisplayLastRecord() {

	if (Inserted = FALSE) then goto DLR_CLEAR
	FILE_ORDHEAD = LastRec
	read FILE_ORDHEAD traps = DLR_CLEAR
	Display()
	return

DLR_CLEAR:
	Clear()
	return
}

/********************************************************************************/

!function SetFocusKey1() {
	setfocus OrderNoBox
	return
}

/********************************************************************************/

!report PrintAll {

!drive FILE_ORDHEAD

!heading {
	PrintTitle()
	PrintHeadings()
}

!final {
	PrintFinal()
}

	PrintRecord()
	end

}

/********************************************************************************/

!report PrintAll1 {

!drive FILE_ORDHEAD index = idx_cust

!heading {
	PrintTitle()
	print "Report by index idx_cust"
	PrintHeadings()
}

!final {
	PrintFinal()
}

	PrintRecord()
	end

}

/********************************************************************************/

!report PrintCurrent {

!temp DataCol,,i2
!temp Element,,i2
!temp PrintHD,,a255

!heading {
	PrintTitle()
}

!title {
	DataCol = 20
	sys.LeftMargin = 10
	sys.LineHeight = sys.CharHeight
	PrintTitle()
	print fit("Order Number:", 19); tab(DataCol); FILE_ORDHEAD.OrderNo
	print fit("Customer Code:", 19); tab(DataCol); FILE_ORDHEAD.CustCode
	print fit("Order Date:", 19); tab(DataCol); FILE_ORDHEAD.OrderdDate
	print fit("Visa/Delta/Account:", 19); tab(DataCol); FILE_ORDHEAD.PayMethod
	print fit("phone/email/online:", 19); tab(DataCol); FILE_ORDHEAD.OrderMethod
	print fit("Special deivery:", 19); tab(DataCol); FILE_ORDHEAD.SDelivery
	print fit("Total Value of Order:", 19); tab(DataCol); FILE_ORDHEAD.OrdTotal
	print fit("discount:", 19); tab(DataCol); FILE_ORDHEAD.Discount
 	end report
}

	end

}

/********************************************************************************/

!function PrintTitle() {

	print lns(2)
	setfont("Arial", 10, FONT_BOLD)
	print "ordhead", sys.Date
	setfont(sys.FontName, sys.FontSize, FONT_NORMAL)
	print
	return
}

/********************************************************************************/

!function PrintHeadings() {

	print
	setfont(sys.FontName, sys.FontSize, FONT_UNDERLINE)
	print tab(1); fit("Order Number", 11);
	print tab(14); fit("Customer Code", 12);
	print tab(27); fit("Order Date", 11);
	print tab(40); fit("Visa/Delta/Account", 5);
	print tab(53); fit("phone/email/online", 5);
	print tab(66); fit("Special deivery", 5);
	print tab(79); fit("Total Value of Order", 16);
	print tab(92); fit("discount", 16);
	print
	setfont(sys.FontName, sys.FontSize, FONT_NORMAL)
	print
	return
}

/********************************************************************************/

!function PrintFinal() {

	print
	print sys.RecordCount: :"s"; " records printed"
	if (Selected = TRUE) {
	FILE_ORDHEAD = TMP_ORDHEAD
		ReadRecord(_UNLOCK, "Main")
	}
	return
}

/********************************************************************************/

!function PrintRecord() {
	print tab(1); fit(FILE_ORDHEAD.OrderNo, 11);
	print tab(14); fit(FILE_ORDHEAD.CustCode, 12);
	print tab(27); fit(FILE_ORDHEAD.OrderdDate, 11);
	print tab(40); fit(FILE_ORDHEAD.PayMethod, 5);
	print tab(53); fit(FILE_ORDHEAD.OrderMethod, 5);
	print tab(66); fit(FILE_ORDHEAD.SDelivery, 5);
	print tab(79); fit(FILE_ORDHEAD.OrdTotal, 16);
	print tab(92); fit(FILE_ORDHEAD.Discount, 16)
	return
}

/********************************************************************************/

!chargrid OFF

/********************************************************************************/
